<?php
class ReferrerDetector_Backup
{
    var $config;

    function ReferrerDetector_Backup()
    {
        $this->__construct();
    }

    function __construct()
    {
        global $rdetector_config;
        $this->config = $rdetector_config;
    }

    function get_panel()
    {
        return sprintf('
        <div id="divBackups">
            <p class="toggler"><span style="font-size:11px; font-weight:normal">%s</span></p>
            <div class="toggled help">%s</div>
            <form class="submit" action="index.php" method="post" id="formBackup" >
                <fieldset>
					<legend>%s</legend>
	                <ul>
	                    <li>
	                        <input type="checkbox" name="entries" checked="checked" id="rd_backupEntries" />
	                        <label for="rd_backupEntries">%s</label>
	                    </li>
	                    <li>
	                        <input type="checkbox" name="excludedURLs" id="rd_excludedURLs" checked="checked" />
	                        <label for="rd_excludedURLs">%s</label>
	                    </li>
	                    <li>
	                        <input type="checkbox" name="options" id="rd_options" checked="checked" />
	                        <label for="rd_options">%s</label>
	                    </li>
	                </ul>
	                <input type="submit" value="%s" id="btnBackup" />
	                <input type="hidden" name="rdetector_action" value="backup" />
				</fieldset>
            </form>
            <div class="submit">
				<fieldset>
					<legend>%s</legend>
                	<input type="file" id="rdRestore" />
                	<input type="submit" style="display:none" id="btnRDRestore" value="%s" onclick="if (confirm(\'%s\')){$(\'#backupResult\').fadeIn();$(\'#rdRestore\').fileUploadStart();}" />
				</fieldset>
            </div>
            <p id="backupResult" style="display:none"></p>
            <div style="display: none" id="divLoadingBackup">
                <img src="%s/images/loading.gif" alt="Loading..." />
            </div>
        </div>
        ',
            __('Get help with this', $this->config['text_domain']),
            __($this->config['backup_help'], $this->config['text_domain']),
            __('Backup into file', $this->config['text_domain']),
            __('Entries', $this->config['text_domain']),
            __('Excluded URLs', $this->config['text_domain']),
            __('Options', $this->config['text_domain']),
            __('Backup', $this->config['text_domain']),
            __('Restore from file', $this->config['text_domain']),
            __('Restore', $this->config['text_domain']),
            __('Are you sure? Restoring will replace all current entries and settings!', $this->config['text_domain']),
            $this->config['plugin_dir']
        );
    }

    function add()
    {
        global $wpdb;
        $data = array();
        if (!empty($_POST['entries']))
        {
            // backup the entries
            $sql = "SELECT * FROM {$this->config['entries_table_name']}";
            $data['entries'] = $wpdb->get_results($sql);
        }

        if (!empty($_POST['excludedURLs']))
        {
            // backup the exluded URLs
            $data['excludedURLs'] = get_option('rdetector_excluded_urls');
        }

        if (!empty($_POST['options']))
        {
            // backup the other options
            $data['options'] = array(
                'rdetector_add_to_every_post' => get_option('rdetector_add_to_every_post'),
                'rdetector_add_to_every_page' => get_option('rdetector_add_to_every_page'),
                'rdetector_message_position'  => get_option('rdetector_message_position'),
                'rdetector_close_icon'        => get_option('rdetector_close_icon'),
            );
        }

        if (empty($data))
        {
            die(__('Nothing selected.', $this->config['text_domain']));
        }

        // save the backup
        $folder = dirname(__FILE__) . '/backup/';
        if (!is_dir($folder))
        {
            mkdir($folder) or die(__('Attempt to create backup folder failed!', $this->config['text_domain']));
        }

        $file = 'backup_' . time() . '.rd';
        if (!ReferrerDetector::save_file("{$folder}{$file}", serialize($data)))
        {
            die(__('Failed to save the backup file.', $this->config['text_domain']));
        }

        printf('%s: <a href="%s">%s</a>',
            __('Backup saved', $this->config['text_domain']),
            $this->config['plugin_dir'] . "backup/$file",
            $file
        );

        exit();
    }

    function restore()
    {
        if (empty($_FILES)) return false;

        $data = unserialize(file_get_contents($_FILES['Filedata']['tmp_name']));

        if (!$data) die(__('Not a valid Referrer Detector backup file.', $this->config['text_domain']));

        $result = array();
        $entry_object = ReferrerDetector::get_instance('ReferrerDetector_Entry');

        if ($data['entries'])
        {
        	$entry_object->del_all();

            foreach ($data['entries'] as $entry)
            {
				$entry_object->restore_one($entry);
            }

            $result[] = __('Entries restored', $this->config['text_domain']);
        }

        if ($data['excludedURLs'])
        {
        	$option_object = ReferrerDetector::get_instance('ReferrerDetector_Option');
        	$option_object->update_or_add('rdetector_excluded_urls', $data['excludedURLs']);

            $result[] = __('Excluded URLs restored', $this->config['text_domain']);
        }

        if ($data['options'])
        {
        	$option_object = ReferrerDetector::get_instance('ReferrerDetector_Option');
            foreach ($data['options'] as $key=>$value)
            {
                $option_object->update_or_add($key, $value);
            }

            $result[] = __('Options restored', $this->config['text_domain']);
        }

		if ($result)
		{
			echo '<script>document.location.reload();</script>';
		}
		else
		{
			_e('Nothing restored (Bad backup file?)', $this->config['text_domain']);
		}
    }
}